from z3 import *

LEN = 81

c = IntVector('c', LEN)

s = Solver()

for i in range(LEN):
    s.add(And(c[i] >= 82, c[i] <= 90))
   

def t(arr):
    for i in range(len(arr) - 1):
        s.add(c[arr[i]] < c[arr[i+1]])


t([27,18,9,0,1,2,11,10])
t([59,50,41,32,40,48])
t([51,50,49,48])
t([6,7,8,17,26])
t([54,64,74,66,76])
t([79,80,70])


def u(r):
    i = 0
    j = 0
    x = []
    while i < len(r):
        if r[i] == '.':
            if r[i+3] == '}':
                off = int(r[i+2])
                j += off
                i += 4
            else:
                off = int(r[i+2:i+4])
                j += off
                i += 5
        elif r[i] == '(':
            x += [c[j]]
            j += 1
            i += 3
    for i in range(82, 91):
        cond = False
        for j in range(len(x)):
            cond = Or(cond, x[j] == i)
        s.add(cond)


u("(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{9}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{18}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{27}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{36}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{45}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{54}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{63}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u(".{72}(.)(.)(.)(.)(.)(.)(.)(.)(.)")
u("(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{1}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{2}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{3}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{4}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{5}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{6}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{7}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u(".{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.).{8}(.)")
u("(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{3}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{6}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{27}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{30}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{33}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{54}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{57}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u(".{60}(.)(.)(.).{6}(.)(.)(.).{6}(.)(.)(.)")
u("(.).{9}(.).{9}(.).{9}(.).{9}(.).{9}(.).{9}(.).{9}(.).{9}(.)")
u(".{8}(.).{7}(.).{7}(.).{7}(.).{7}(.).{7}(.).{7}(.).{7}(.).{7}(.)")


if s.check() == sat:
    model = s.model()
    
    c_res = [model[c[i]].as_long() for i in range(LEN)]
    b = ""
    a = ""

    d1 = {'R':'aa', 'S':'ab', 'T':'ac', 'U':'ba', 'V':'bb', 'W':'bc', 'X':'ca', 'Y':'cb', 'Z':'cc'}
    d2 = {'aaa':'0', 'aab':'1', 'aac':'2', 'aba':'3', 'abb':'4', 'abc':'5', 'aca':'6', 'acb':'7', 'acc':'8', 'baa':'9',
            'bab':'A', 'bac':'B', 'bba':'C', 'bbb':'D', 'bbc':'E', 'bca':'F', 'bcb':'G', 'bcc':'H', 'caa':'I', 'cab':'J',
                'cac':'K', 'cba':'L', 'cbb':'M', 'cbc':'N', 'cca':'O', 'ccb':'P', 'ccc':'Q'}

    for i in c_res:
        b += d1[chr(i)]

    for i in range(0, len(b), 3):
        a += d2[b[i:i+3]]

    print('p4{' + a + '}')

    
else:
    print("unsat")